


#include "rusage.h"

#define THRFLAG_NOT_ACTIVE 0
#define THRFLAG_INIT 1
#define THRFLAG_ACTIVE 2
#define THRFLAG_IDLE 4
#define THRFLAG_RESET 5
#define THRFLAG_SEM_WAIT 7
#define THRFLAG_AWAIT_INPUT 10
#define THRFLAG_SEMCLEAR 11
#define THRFLAG_RETURNED 12
#define THRFLAG_INPUT_WAIT 13

#define THRFLAG_PORTAUDIO_STARTSTOP 100
#define THRFLAG_OPEN_RX_SNDIN 101
#define THRFLAG_CLOSE_RX_SNDIN 102
#define THRFLAG_OPEN_RX_SNDOUT 103
#define THRFLAG_CLOSE_RX_SNDOUT 104
#define THRFLAG_OPEN_TX_SNDIN 105
#define THRFLAG_CLOSE_TX_SNDIN 106
#define THRFLAG_OPEN_TX_SNDOUT 107
#define THRFLAG_CLOSE_TX_SNDOUT 108
#define THRFLAG_SET_RX_IO 109
#define THRFLAG_TX_SETUP 110
#define THRFLAG_PORTAUDIO_STOP 111
#define THRFLAG_SET_SDRIP_ATT 112
#define THRFLAG_SET_SDRIP_FREQUENCY 113

#define THRFLAG_KILL -1

#define THREAD_RX_ADINPUT 0
#define THREAD_RX_RAW_NETINPUT 1
#define THREAD_RX_FFT1_NETINPUT 2
#define THREAD_RX_FILE_INPUT 3
#define THREAD_SDR14_INPUT 4
#define THREAD_RX_OUTPUT 5
#define THREAD_SCREEN 6
#define THREAD_TX_INPUT 7
#define THREAD_TX_OUTPUT 8
#define THREAD_WIDEBAND_DSP 9
#define THREAD_NARROWBAND_DSP 10
#define THREAD_USER_COMMAND 11
#define THREAD_TXTEST 12
#define THREAD_POWTIM 13
#define THREAD_RX_ADTEST 14
#define THREAD_CAL_IQBALANCE 15
#define THREAD_CAL_INTERVAL 16
#define THREAD_CAL_FILTERCORR 17
#define THREAD_TUNE 18
#define THREAD_LIR_SERVER 19
#define THREAD_PERSEUS_INPUT 20
#define THREAD_RADAR 21
#define THREAD_SECOND_FFT 22
#define THREAD_TIMF2 23
#define THREAD_BLOCKING_RXOUT 24
#define THREAD_SYSCALL 25
#define THREAD_SDRIP_INPUT 26
#define THREAD_EXCALIBUR_INPUT 27
#define THREAD_HWARE_COMMAND 28
#define THREAD_MAX 29

extern signed char thread_command_flag[THREAD_MAX];
extern signed char thread_status_flag[THREAD_MAX];
extern int thread_waitsem[THREAD_MAX];
extern char mouse_thread_flag;
extern float thread_workload[THREAD_MAX];
extern double thread_tottim1[THREAD_MAX];
extern double thread_cputim1[THREAD_MAX];
extern double thread_tottim2[THREAD_MAX];
extern double thread_cputim2[THREAD_MAX];
#if RUSAGE_OLD != TRUE
extern int thread_pid[THREAD_MAX];
#endif

extern char *thread_names[THREAD_MAX];
extern int rxin_local_workload_reset;
extern int rx_input_thread;
extern int threads_running;


#define SEM_SCREEN 0
#define SEM_FFT2 1
#define SEM_TIMF2 2
#define SEM_KEYBOARD 3
#define SEM_TXINPUT 4
#define SEM_MOUSE 5
#define SEM_SYSCALL 6
#define MAX_LIRSEM 7
// semaphores 0 to SEM_AUTOINIT_MAX-1 are initiated in lir_sem_init()
// The remaining ones have to be initiated individually.
#define SEM_AUTOINIT_MAX SEM_KEYBOARD

#define EVENT_TIMF1 0
#define EVENT_FFT1 1
#define EVENT_RX_START_DA 2
#define EVENT_BASEB 3
#define EVENT_PERSEUS_INPUT 4
//  - - - - - - - - - - - - -
#define EVENT_BLOCKING_RXOUT 5
#define EVENT_PORTAUDIO_RXREADY 6
#define MAX_LIREVENT 7
// events 0 to EVENT_AUTOINIT_MAX-1 are initiated in init_semaphores()
// The remaining ones have to be initiated individually.
#define EVENT_AUTOINIT_MAX EVENT_BLOCKING_RXOUT

//#define EVENT_SCREEN 3
//#define EVENT_FFT2 4
//#define EVENT_TIMF2 5


void linrad_thread_create(int no);
void linrad_thread_stop_and_join(int no);
void init_semaphores(void);

#if RUSAGE_OLD == TRUE
double lir_get_thread_time(void);
#else
double lir_get_thread_time(int no);
#endif
double lir_get_cpu_time(void);

